/*
 * game.cpp
 *
 *  Created on: 24/mar/2014
 *      Author: bertini
 */

#include <iostream>
#include <vector>

#include "Character.h"
#include "Knight.h"
#include "Wizard.h"
#include "MageKnight.h"
#include "Monster.h"
#include "MeleeWeapon.h"
#include "MissileWeapon.h"
#include "Tile.h"
#include "GameMap.h"
#include "CharacterFactory.h"

int main() {
	GameMap* map1 = new GameMap(2,2);
	Tile t1(1,true);
	Tile t2(2, false);
	Tile t3(3, true);
	Tile t4(4, false);
	map1->setTile(0, 0, t1);
	map1->setTile(0, 1, t2);
	map1->setTile(1, 0, t3);
	map1->setTile(1, 1, t4);
	GameMap map2(*map1);
	delete map1;
	map2.printMap();

	Character* hero = CharacterFactory::makeKnight("Boromir", 36, 1, 6);
	Character* hero2 = CharacterFactory::makeWizard("Gandalf", 30, 2, 6);
	Character* hero3 = CharacterFactory::makeKnight("Isildur", 30, 3, 8, CharacterFactory::MageKnightT);

	std::vector<Character*> heroTeam;
	heroTeam.push_back(hero);
	heroTeam.push_back(hero2);
	heroTeam.push_back(hero3);


	Weapon* fang = new MeleeWeapon(3, false, MeleeWeapon::Fang);
	Character* orc = new Monster(30, 1, 1);
	orc->setWeapon(fang);
	orc->setName("orc");

	for (int i = 0; i < heroTeam.size(); i++) {
		Wizard* wizardHero = dynamic_cast<Wizard*>(heroTeam[i]);
		if (wizardHero) {
			wizardHero->doMagic(*orc);
		} else {
			int damage = heroTeam[i]->fight(*orc);
			if (damage)
				std::cout << heroTeam[i]->getName() << " hits the orc - damage: " << damage
						<< " points" << std::endl;

			Weapon* magicSword = new MeleeWeapon(7, true, MeleeWeapon::Sword);
			heroTeam[i]->setWeapon(magicSword);
			damage = heroTeam[i]->fight(*orc);
			if (damage)
				std::cout << heroTeam[i]->getName() << " hits the orc - damage: " << damage
						<< " points" << std::endl;
		}
	}


	delete hero;
	delete hero2;
	delete hero3;
	delete orc;
}
